; Spectrum equates

; Emulator interface

ScoreReportAddr         equ $FFFD                       ; Binary score here
ScoreReportVector       equ $FFFF                       ; We execute here to flag the score to the emulator

; This file is messy, I've had to recreate it from a disassembly of the game

Attr_White              equ $07                         ;
cBS                     equ $08                         ;
cCLS                    equ $0C                         ;
cCret                   equ $0D                         ;
ScreenBase              equ $4000                       ;
AttrBase                equ $5800                       ;
lScreen                 equ $1800                       ;
lAttrs                  equ $300                        ;

; These are equates for the game

StartY                  equ $2BC

nStars                  equ 40
nProjs                  equ 10
nObjes                  equ 8

; Game constants

Zdvstep                 equ -28                         ; Accelerate rate
MinSP                   equ -180                        ; Slowest
InitSP                  equ -171                        ;
MaxSP                   equ -1200                       ; Fastest

ProjSP                  equ 1400                        ; Projectile speed offset
HighY                   equ 10000                       ; Planet max height
LowY                    equ 500                         ;        min

; "Cursor" movement

Xdtstep                 equ 5                           ;
Ydtstep                 equ 5                           ;
dDX                     equ 2                           ;
dDY                     equ 2                           ;

;
; Star memory definition

        struct
dStarX                  ds 2
dStarY                  ds 2
dStarZ                  ds 2
dStarAddr               ds 2
dStarBit                ds 1
dStarAlive              ds 1
lStar                   equ *
        send

; Projectile memory definition

        struct
dProjX                  ds 2
dProjY                  ds 2
dProjZ                  ds 2
dProjAddr               ds 2
dProjBit                ds 1
dProjLife               ds 1
dProjDX                 ds 2
dProjDY                 ds 2
dProjDZ                 ds 2
dProjOldZ               ds 1
dProjOldX               ds 1
dProjOldY               ds 1
lProj                   equ *
        send

; Line definition - used to store the information (registers mainly) we need to undraw an object's lines again

        struct
AnypCode                ds 2
AnyA                    ds 1
AnyB                    ds 1
AnyC                    ds 1
AnyD                    ds 1
AnyE                    ds 1
AnyL                    ds 1
AnyH                    ds 1
AnyA1                   ds 1
AnyC1                   ds 1
AnyE1                   ds 1
AnyL1                   ds 1
AnyH1                   ds 1

AnyBit                  equ *
AnySxx                  ds 1

AnySyy                  ds 1
AnyHV                   ds 1
AnyIXl                  ds 1
AnyIXh                  ds 1
lObjeLine               equ *
        send

; Object definition
; This is incomplete
; Object deltas

        struct
dObjeX                  ds 2    ; 0
dObjeY                  ds 2    ; 2
dObjeZ                  ds 2    ; 4
dObjeDY                 ds 2
dObjeState              ds 1    ; 8
dObjeCnt                ds 1
dObjepMove              ds 2
dObjeFlag               ds 1    ; 12
; Bit 0 1 = Alive
; Bit 1 1 = Can Fire
; Bit 2 1 = Can be shot
; Bit 3 1 = Can be hit
; Bit 4 1 = Can explode
; Bit 5 1 = Does not stop bullets
; Bit 6 1 = Scores if flown through
; Bit 7 1 = ?

dObjeHSize              ds 1
dObjeOldX               ds 1        ; 14
dObjeOldZ               ds 1
dObjepShp               ds 2
dObjenShp               ds 1
dObjedX                 ds 2        ; 19
dObjedY                 ds 2
dObjedZ                 ds 2
dObjeCol                ds 1        ; 25
dObjeMiss               ds 1
dObjeOldY               ds 1
dObjeTimeToNextRecalc   ds 1

dObjeMissAngle          equ *       ; 29
dW_Unk1                 ds 2        ; 29
dW_Unk2                 ds 2        ; 31
dObjeShot               ds 2        ; 33
dObjeMissed             ds 2        ; 35
dObjeCollided           ds 2        ; 37
                        ds 1        ; 39
                        ds 1        ; 40
                        ds 1        ; 41
dW_UnkA                 ds 2        ; 42
dW_UnkB                 ds 2        ; 44
dW_UnkC                 ds 2        ; 46
dW_UnkD                 ds 2        ; 48

dObjeLines              ds lObjeLine * 8 ; This is a list of lines, number depends on object

        send

; The length of an object is great enough to store all the line undraw data
lObje                   equ $100

;

