GameControlsDone        CALL Init_Game_IRQ

                        CALL InitDisplayFurniture

                        ; Setup the IRQ if required

                        LD A,(optVarDisplayMode)
                        CP $03
                        JP Z GameNoStatus

                        CALL InitClock
                        CALL InitScore

                        CALL IRQ_Game

                        LD HL,sInitial
                        CALL ScrollMessage

GameNoStatus            LD HL,0
                        LD (Score),HL

                        EI                              ; Start the interrupt running

                        ; Fall into

Play_Sheet              LD HL,ObjeTable                 ; Clear all the objects, etc
                        LD DE,ObjeTable+1               ;
                        LD BC,lTables                   ;
                        LD (HL),$00                     ;
                        LDIR                            ;

                        CALL SetupGameOptions           ;

                        CALL SetupDisplayEtc            ;

                        CALL SetupNoises                ;

                        CALL BuildBitTablesEtc          ;

                        CALL InitMapOfUniverse          ;

                        ; Count the number of planets to liberate

                        LD HL,Map+$100                  ;
                        LD B,0                          ;
PlanetCntLp             LD A,(HL)                       ;
                        AND $03                         ;
                        CP $03                          ;
                        CCF                             ;
                        LD A,B                          ;
                        ADC A,$00                       ;
                        LD B,A                          ;
                        INC L                           ;
                        JR NZ PlanetCntLp               ;

                        LD A,B                          ;
                        LD (MainBaseCnt),A              ;

                        LD A,nStars                     ;
                        CALL InitStars                  ;
                        CALL InitProj                   ;

                        LD A,$01                        ;
                        LD (GameMode_SPT),A             ;

                        CALL GenYTab                    ;
                        CALL Gen192Tab                  ;
                        LD HL,InitSP                    ;
                        LD (DeltaZ),HL                  ;

                        LD A,7                          ; nShields
                        LD (EnergyLevel),A              ;

                        CALL ShowEnergyLevel            ;

Game_Lp                 CALL LD476                      ;
                        CALL ClearActiveDisplayArea     ;

LC759                   CALL LC8BC                      ;

                        LD A,(GameState)                ;
                        OR A                            ;
                        JR NZ LC76C                     ;

                        ; Leave the game

                        DI                              ;

                        CALL FadeScreen                 ;

                        LD HL,(Score)                   ;
                        LD A,$00                        ;
GameEndState            EQU *-1                         ;
                        RET                             ;

;

LC76C                   CP $01                          ;
                        JR NZ LC788                     ;

                        CALL ClearObjects               ;
                        CALL ClearStarsAndProjs         ;
                        CALL LD4D6                      ;

                        ; Move us

                        LD A,(CurrMapPosition)          ;
                        ADD A,$00                       ;
LC77D                   EQU *-1                         ;
                        LD (CurrMapPosition),A          ;

                        LD A,$02                        ;
                        LD (GameMode_SPT),A             ;

                        JR Game_Lp                      ;

;

LC788                   CP $03                          ;
                        JR NZ LC799                     ;

                        CALL ClearObjects               ;
                        CALL ClearStarsAndProjs         ;

                        LD A,$01                        ;
                        LD (GameMode_SPT),A             ;

                        JR Game_Lp                      ;

LC799                   CP $02                          ;
                        JR NZ Game_Lp                   ;

                        CALL ClearObjects               ;
                        CALL ClearStarsAndProjs         ;
                        CALL LD4D6                      ;

                        LD A,(CurrPlanetType)           ;
                        AND $03                         ;
                        CALL CreatePlanetMap            ;

                        LD A,$88                        ;
                        LD (LDA61),A                    ;
                        LD A,$00                        ;
                        LD (GameMode_SPT),A             ;
                        JR LC759                        ;

;

SetupGameOptions        LD A,(optVarDisplayMode)        ;
                        OR A                            ;
                        JR Z SGO_DispMode0              ;

                        DEC A                           ;
                        JR Z SGO_DispMode1              ;

                        DEC A                           ;
                        JR Z SGO_DispMode2              ;

                        LD HL,YTable                    ;
                        LD A,$C0                        ;
                        JR SGO_GotDispSize              ;

SGO_DispMode0           LD HL,YTable+10                 ;
                        LD A,$A4                        ;
                        JR SGO_GotDispSize              ;

SGO_DispMode1           LD HL,YTable                    ;
                        LD A,$A0                        ;
                        JR SGO_GotDispSize              ;

SGO_DispMode2           LD HL,YTable                    ;
                        LD A,$A8                        ;

SGO_GotDispSize         LD (ScreenHeight),A             ;
                        LD (ScreenpYT_Top),HL           ;

                        LD A,(optSkillLevel)            ;
                        AND $07                         ;
                        LD HL,optSkillLevelTab          ;
                        ADD A,L                         ;
                        LD L,A                          ;
                        LD A,H                          ;
                        ADC A,$00                       ;
                        LD H,A                          ;

                        LD DE,6                         ;
                        LD A,(HL)                       ;
                        LD (optSkillLevel_A),A          ;

                        ADD HL,DE                       ;
                        LD A,(HL)                       ;
                        LD (optSkillLevel_B),A          ;

                        ADD HL,DE                       ;
                        LD A,(HL)                       ;
                        LD (optSkillLevel_C),A          ;

                        ADD HL,DE                       ;
                        LD A,(HL)                       ;
                        LD (optSkillLevel_D),A          ;

                        ADD HL,DE                       ;

                        XOR A                           ;
                        LD (FireAtPlayer),A             ;

                        LD A,(optMissileType)           ;
                        LD B,A                          ;
                        OR A                            ;
                        JR Z DisableFiringAtPlayer      ;

                        BIT 2,A                         ;
                        LD A,0                          ;
                        JR NZ SGO_SetMissileError       ;

                        LD A,3                          ;
SGO_SetMissileError     LD (MissileAimError),A          ;

                        LD A,B                          ;
                        BIT 1,A                         ;
                        LD A,20                         ;
                        JR NZ SGO_SetMissileSpeed       ;

                        LD A,40                         ;
SGO_SetMissileSpeed     LD (MissileSpeed),A             ;

                        LD A,B                          ;
                        BIT 3,A                         ;
                        JR Z SGO_X                      ;

                        LD A,15                         ;
                        LD (MissileSpeed),A             ;

                        LD A,$0F                        ;
                        LD (optSkillLevel_D),A          ;
                        JR SGO_X                        ;

DisableFiringAtPlayer   LD A,$C9                        ; RET
                        LD (FireAtPlayer),A             ;

SGO_X                   RET                             ;

; Some option tables

optSkillLevelTab        DEFB $01,$01,$01,$01,$01,$02    ;
                        DEFB $06,$04,$02,$02,$01,$01    ;
                        DEFB $04,$10,$18,$20,$28,$3F    ;
                        DEFB $7F,$3F,$1F,$1F,$0F,$1F    ;

LC8BC                   XOR A
                        LD (GameState),A
                        LD (nMissiles),A

                        LD A,$07
                        LD (ArrowDirn),A

                        LD HL,$8000
                        LD (SheetZ),HL

                        LD HL,$0000
                        LD (GroundX),HL

                        CALL InitProj

                        CALL KillAllObjects

                        LD A,nStars
                        CALL InitStars

                        LD A,(GameMode_SPT)

                        OR A
                        PUSH AF
                        CALL Z SetupPlanetMode
                        POP AF

                        DEC A
                        PUSH AF
                        CALL Z SetupSpaceMode
                        POP AF

                        DEC A
                        CALL Z SetupTunnelMode

                        LD HL,$0000
                        LD (LC9F3),HL
                        LD (LC9F5),HL

                        LD A,$10
                        LD (LDA12),A

                        ; I'm assuming this is the game loop

        if enabled bFrameLock

Loop                    ld a,(cSecCount)                ; Wait until this one ends
                        ld b,a                          ;

FrameLock               ld a,(SecCount)                 ;
                        cp b                            ;
                        jr z FrameLock                  ;

                        ld (cSecCount),a                ; Save it
        else
Loop                    equ *
        endif


                        CALL LD4FF

                        ; See if we have any more main bases to liberate

LC903                   LD A,$00
MainBaseCnt             EQU *-1
                        OR A
                        JR NZ Main_0

                        ; We've won - exit

                        LD A,$02
                        LD (GameEndState),A
                        RET

                        ; Carry on

Main_0                  LD HL,(GroundY)                 ;
                        LD DE,(DeltaY)                  ;
                        ADD HL,DE                       ;
                        LD (GroundY),HL                 ;

                        LD HL,(GroundX)                 ;
                        LD DE,(DeltaX)                  ;
                        ADD HL,DE                       ;
                        LD (GroundX),HL                 ;

                        EXX                             ;
                        LD HL,(LC9F5)                   ;
                        EXX                             ;
                        LD HL,(LC9F3)                   ;
                        CALL LC9F7                      ;

                        LD (LC9F3),HL                   ;
                        EXX                             ;
                        LD (LC9F5),HL                   ;

                        LD A,(GameMode_SPT)             ;
                        CP $02                          ;
                        CALL NZ ShowStars               ;

                        CALL ShowObjects                ;

                        CALL ShowProj                   ;

                        CALL AlterSteps                 ;
                        JR NC LC94E                     ;

                        LD A,$03                        ;
                        LD (GameState),A                ;

LC94E                   CALL DrawSights                 ;
                        CALL CheckPlayerFire            ;

                        LD A,$F7                        ;
                        IN A,($FE)                      ;
                        OR $E0                          ;
                        CP $FE                          ;
                        JR NZ Main_1                    ;

                        LD A,$EF                        ;
                        IN A,($FE)                      ;
                        OR $E0                          ;
                        INC A                           ;
                        JR NZ Main_1                    ;

                        LD A,$01                        ;
LC968                   EQU *-1                         ;
                        OR A                            ;
                        JR NZ LC9B2                     ;

                        LD A,(GameMode_SPT)             ;
                        CP $02                          ;
                        JR Z Main_1                     ;

                        DEC A                           ;
                        JR NZ LC97E                     ;

                        CALL ClearActiveDisplayArea     ;
                        CALL ShowSpaceInfo              ;

                        JR LC9A4                        ;

LC97E                   CALL ClearActiveDisplayArea     ;

                        CALL ShowPlanetData             ;

LC984                   LD A,$F7                        ;
                        IN A,($FE)                      ;
                        BIT 0,A                         ;
                        JR Z LC984                      ;

                        LD BC,$03E8                     ;
LC98F                   CPI                             ;
                        JP PE LC98F                     ;

                        LD A,$F7                        ;
                        IN A,($FE)                      ;
                        BIT 0,A                         ;
                        JR Z LC984                      ;

LC99C                   LD A,$F7                        ;
                        IN A,($FE)                      ;
                        BIT 0,A                         ;
                        JR NZ LC99C                     ;

LC9A4                   CALL ClearActiveDisplayArea     ;
                        LD A,$01                        ;
                        LD (LC968),A                    ;
                        JR LC9B2                        ;

Main_1                  XOR A                           ;
                        LD (LC968),A                    ;
LC9B2                   CALL Rand                       ;
                        LD A,E                          ;
                        LD R,A                          ;
                        LD HL,$0000                     ;
SheetZ                  EQU *-2                         ;
                        LD DE,(DeltaZ)                  ;
                        ADD HL,DE                       ;
                        LD (SheetZ),HL                  ;
                        LD A,$00                        ;
GameState               EQU *-1                         ;
                        OR A                            ;
                        RET NZ                          ;

                        LD A,$F7                        ;
                        IN A,($FE)                      ;
                        OR $E0                          ;
                        CP $F3                          ;
                        JR NZ LC9DF                     ;

                        LD A,$EF                        ;
                        IN A,($FE)                      ;
                        OR $E0                          ;
                        INC A                           ;
                        JR NZ LC9DF                     ;

                        INC A                           ;
                        LD (GameEndState),A             ;
                        RET                             ;

LC9DF                   LD A,(SheetZ+1)                 ;
                        BIT 7,A                         ;
                        JP Z Loop                       ;

                        LD A,$00                        ;
EnergyLevel             EQU *-1                         ;
                        BIT 7,A                         ;
                        JP Z LC903                      ;

                        XOR A                           ;
                        LD (GameEndState),A             ;
Ret                     RET                             ;

LC9F3                   DEFW $FF11
LC9F5                   DEFW $EDFF

LC9F7                   ADD HL,DE                       ;
                        BIT 7,D                         ;
                        EXX                             ;
                        LD DE,$0000                     ;
                        JR Z LCA03                      ;

                        LD DE,$FFFF                     ;
LCA03                   ADC HL,DE                       ;
                        EXX                             ;
                        RET                             ;

SetupSpaceMode          LD A,50                         ;
                        LD (TunnelRequestCnt),A         ;

                        LD A,$01                        ;
SpaceInitialnStars      EQU *-1                         ;
                        JP InitStars                    ;

AddSomeStars            LD B,A                          ;
                        LD A,(Stars_nDem)               ;
                        ADD A,B                         ;
                        LD (Stars_nDem),A               ;
                        RET                             ;

SubSomeStars            LD B,A                          ;
                        LD A,(Stars_nDem)               ;
                        SUB B                           ;
                        RET M                           ;

                        LD (Stars_nDem),A               ;
                        RET                             ;

SetupTunnelMode         LD HL,$0000                     ;
                        LD (LD9D3),HL                   ;
                        LD (LD9D5),HL                   ;
                        LD (LD9D7),HL                   ;
                        LD (LD9D9),HL                   ;
                        LD (LD9DE),HL                   ;
                        LD (LD9E0),HL                   ;

                        LD A,$01                        ;
                        LD (TunnelSegmentCount),A       ;

                        LD A,$01                        ;
                        LD (TunnelSectionCount),A       ;

                        CALL TunnelSetup                ;
                        LD (pTunnelDefn),HL             ;

                        LD HL,$1000                     ;
                        LD (LD83A),HL                   ;

                        LD HL,$1400                     ;
                        LD (LD844),HL                   ;

                        LD HL,$FF4C                     ;
                        LD (LD83D),HL                   ;

                        LD HL,$FF24                     ;
                        LD (LD847),HL                   ;

                        LD A,15                         ;
                        LD (TunnelObjeCnt),A            ;

                        LD HL,LD81B                     ;
                        LD (LD819),HL                   ;

                        RET                             ;

                        DEFB $00,$00,$00                ;

LD161                   LD A,$E7                        ;
                        IN A,($FE)                      ;
                        BIT 1,A                         ;
                        JR NZ LD161                     ;

LD169                   LD A,$E7                        ;
                        IN A,($FE)                      ;
                        BIT 1,A                         ;
                        JR Z LD169                      ;

                        RET                             ;

CauseDamageToPlayer     LD A,(EnergyLevel)              ;
                        SUB $00                         ;
optSkillLevel_A         EQU *-1                         ;
                        LD (EnergyLevel),A              ;

                        ; Set the bar position

ShowEnergyLevel         LD HL,BarPosTable               ;
                        ADD A,L                         ;
                        LD L,A                          ;
                        LD A,H                          ;
                        ADC A,$00                       ;
                        LD H,A                          ;

                        LD A,(HL)                       ;
                        LD (EnergyBarPos),A             ;
                        RET                             ;

; Energy bar positions

BarPosTable             DEFB $00,$11,$22,$33,$44,$55,$66,$76

SpaceportShipShot       LD HL,(LD2B9)                   ;
                        LD A,(HL)                       ;
                        AND $F0                         ;
                        CP $20                          ;
                        JR NZ SpaceshipShot             ;

                        DEC (HL)                        ;
                        LD A,(HL)                       ;
                        CP $20                          ;
                        JR NZ SpaceshipShot             ;

                        LD (HL),$00                     ;
                        LD HL,sSpaceportDestroyed       ;
                        CALL ScrollMessage              ;

SpaceshipShot           LD A,4                          ;
                        CALL AddSomeStars               ;

                        LD HL,ExplosionOfObject         ;
                        CALL TurnIntoExplosion          ;

                        LD DE,1                         ;
                        CALL Add_DE_ScoreUnlessDiff     ;

                        LD A,(optGameFormat)            ;
                        CP $02                          ;
                        RET NZ                          ;

                        JP LD25D                        ;

;

Add_DE_ScoreUnlessDiff  LD A,(optSkillLevel)            ;
                        CP $05                          ;
                        RET Z                           ;

Add_DE_ToScore          LD HL,(Score)
                        LD A,L
                        ADD A,E
                        DAA
                        LD L,A
                        LD A,H
                        ADC A,D
                        DAA
                        LD H,A
                        JR C ScoreOverflow

                        LD (Score),HL
                        RET

                        ;

ScoreOverflow           LD HL,sEndMessage
                        CALL ScrollMessage

                        LD HL,$0001
                        LD (Score),HL
                        RET

sEndMessage             DEFB $07,"Well done ! Pity I'm too tired to deal with this !",$00,$FF

; Changes an object in some way?

TurnIntoExplosion       LD (IY+dObjeState),1            ;

                        LD (IY+dW_Unk2),HL              ;

                        LD (IY+dObjeFlag),1             ;

                        LD HL,DrawExplosion             ;
                        LD (IY+dObjepMove),HL           ;

                        LD HL,Ret                       ;
                        LD (IY+dObjeShot),HL            ;
                        LD (IY+dObjeCollided),HL        ;
                        LD (IY+dObjeMissed),HL          ;
                        RET                             ;

;

SpaceshipCollision      CALL CauseDamageToPlayer        ;

                        LD A,4
                        CALL AddSomeStars

                        LD A,(optGameFormat)            ;
                        CP $02                          ;
                        JR Z LD25D                      ;

                        RET                             ;

;

SpaceshipMissed         LD A,4                          ;
                        CALL AddSomeStars               ;

LD25D                   LD A,(SpaceShipProbability)     ;
                        ADD A,$03                       ;
                        LD (SpaceShipProbability),A     ;
                        RET                             ;

TowerShot               LD A,(IY+dObjeCol)              ;
                        LD B,A                          ;
                        AND $F8                         ;
                        LD C,A                          ;
                        LD A,B                          ;
                        DEC A                           ;
                        AND $07                         ;
                        OR C                            ;
                        LD (IY+dObjeCol),A              ;

                        LD A,(IY+dObjeState)            ;
                        CP $02                          ;
                        JR Z LD281                      ;

                        LD A,4                          ;
                        CALL AddSomeStars               ;

LD281                   LD HL,(IY+dObjeDY)              ;
                        LD DE,$FF38                     ;
                        ADD HL,DE                       ;
                        LD (IY+dObjeDY),HL              ;

                        LD (IY+dObjeState),$02          ;
                        RET                             ;

LD296                   LD A,(IY+dObjeCol)              ;
                        DEC A                           ;
                        CP $40                          ;
                        LD (IY+dObjeCol),A              ;
                        RET NZ                          ;

                        LD HL,sBaseDestroyed            ;
                        CALL ScrollMessage              ;

                        LD A,(nBasesOnPlanet)           ;
                        DEC A                           ;
                        LD (nBasesOnPlanet),A           ;
                        CALL Z PlanetLiberated          ;

                        LD (IY+dObjeShot),low TowerShot    ;
                        LD (IY+dObjeShot+1),high TowerShot ;

                        LD HL,$0000                     ;
LD2B9                   EQU *-2                         ;
                        LD (HL),$00                     ;
                        LD B,L                          ;
                        CALL LDA99                      ;
                        CALL LDAA8                      ;
                        LD E,$03                        ;
LD2C6                   CALL LD337                      ;
                        CALL LDAAF                      ;
                        DEC E                           ;
                        JR NZ LD2C6                     ;

                        CALL LDA99                      ;
                        LD E,$05                        ;
LD2D4                   CALL LD33C                      ;
                        CALL LDAA8                      ;
                        DEC E                           ;
                        JR NZ LD2D4                     ;

                        ; Score this

                        LD A,(optSkillLevel)
                        CP $04
                        LD DE,$0010
                        JR C ADS_1

                        LD DE,$0001
ADS_1                   CALL Add_DE_ToScore
                        JP TowerShot

; We have liberated this planet

PlanetLiberated         LD A,(CurrMapPosition)
                        LD L,A
                        LD H,(high Map) +1

                        ; Was this a main base?

                        LD A,(HL)
                        CPL
                        AND $03
                        CALL Z DecMainBaseCnt

                        LD (HL),$80
                        LD HL,sLiberated
                        CALL ScrollMessage
                        RET

; Decrement the main base count

DecMainBaseCnt          LD A,(MainBaseCnt)
                        DEC A
                        LD (MainBaseCnt),A

                        RET

sBaseDestroyed          DEFB $05,"Base ",$06,"Destroyed !",$00,$FF
sLiberated              DEFB $07,"Planet",$06,"Liberated !",$00,$FF

LD337                   PUSH BC                         ;
                        LD D,3                          ;
                        JR LD33F                        ;

LD33C                   PUSH BC                         ;
                        LD D,5                          ;
LD33F                   LD L,B                          ;
                        LD A,(HL)                       ;
                        AND $F0                         ;
                        JR NZ LD34B                     ;

                        LD A,(HL)                       ;
                        OR A                            ;
                        JR Z LD34B                      ;

                        DEC A                           ;
                        LD (HL),A                       ;
LD34B                   CALL LDA8B                      ;
                        DEC D                           ;
                        JR NZ LD33F                     ;

                        POP BC                          ;
                        RET                             ;

SomeObjectHit           CALL CauseDamageToPlayer        ;

SomeObjectMissed        LD A,(IX+dObjeState)            ;
                        CP $02                          ;
                        RET Z                           ;

                        LD A,4                          ;
                        JP AddSomeStars                 ;

ForceFieldMissed        CALL CauseDamageToPlayer        ;

                        LD A,2                          ;
                        JP AddSomeStars                 ;

LD369                   CALL AccurateCollisionCheck     ;
                        JR C ForceFieldMissed           ;

                        LD DE,1                         ;
                        CALL Add_DE_ScoreUnlessDiff     ;

                        LD A,2                          ;
                        JP AddSomeStars                 ;

;

MissileShot             LD (IY+dObjeState),$FF          ;

                        LD A,3                          ;
                        CALL AddSomeStars               ;

                        LD HL,ExplosionOfMissile        ;
                        JP TurnIntoExplosion            ;

;

PlayerShot              CALL CauseDamageToPlayer        ;

ProjMiss                LD A,3
                        JP AddSomeStars

LD390                   CALL AccurateCollisionCheck     ;
                        JR C LD3C9                      ;

                        ; Add to our energy

RefuelEnergy            LD A,(EnergyLevel)              ;
                        ADD A,$00                       ;
optSkillLevel_B         EQU *-1                         ;
                        CP $08                          ;
                        LD (EnergyLevel),A              ;
                        JP C ShowEnergyLevel            ;

                        ; It's saturated

                        LD A,$07                        ;
                        LD (EnergyLevel),A              ;
                        JP ShowEnergyLevel              ;

;

LD3AA                   CALL AccurateCollisionCheck     ;
                        RET C                           ;

                        LD HL,(LD2B9)                   ;
                        LD A,(HL)                       ;
                        AND $F0                         ;
                        CP $10                          ;
                        JR NZ LD3C6                     ;

                        DEC (HL)                        ;
                        LD A,(HL)                       ;
                        CP $11                          ;
                        JR NC LD3C6                     ;

                        LD (HL),$00                     ;
                        LD HL,sFuelDumpExhausted        ;
                        CALL ScrollMessage              ;
LD3C6                   JP RefuelEnergy                 ;

LD3C9                   LD A,$10                        ;
                        LD (FuelSquareProbability),A    ;
                        RET                             ;

sFuelDumpExhausted      DEFB $07,"Fuel dump exhausted",$00,$FF
sSpaceportDestroyed     DEFB $06,"Spaceport destroyed",$00,$FF

LD3FB                   LD A,$01                        ;
                        CALL AccurateCollisionCheck     ;
                        JR C LD40D                      ;

                        LD A,$01                        ;
                        LD (GameState),A                ;

                        LD A,(IX +18)                   ;
                        LD (LC77D),A                    ;

LD40D                   LD A,3
                        JP AddSomeStars

; Driven into planet

DrivenIntoPlanet        LD A,$02                        ;
                        LD (GameState),A                ;

                        LD A,(optGameFormat)            ;
                        OR A                            ;
                        JR Z DIP_1

PlanetMissed            LD A,$00                        ;
PlanetProbabilityVal    EQU *-1                         ;
                        LD (PlanetProbability),A        ;

DIP_1                   LD A,8
                        JP AddSomeStars

;

AccurateCollisionCheck  LD HL,(YDiveRatio)              ;
                        SRA H                           ;
                        RR L                            ;
                        LD A,H                          ;
                        XOR $80                         ;
                        LD H,A                          ;
                        LD E,(IX+dW_UnkB)               ;
                        LD A,(IX+dW_UnkB+1)             ;
                        XOR $80                         ;
                        LD D,A                          ;
                        SBC HL,DE                       ;
                        RET C                           ;

                        ADD HL,DE                       ;
                        DEC HL                          ;
                        LD E,(IX+dW_UnkD)               ;
                        LD A,(IX+dW_UnkD+1)             ;
                        XOR $80                         ;
                        LD D,A                          ;
                        SBC HL,DE                       ;
                        CCF                             ;
                        RET C                           ;

                        LD HL,(XTurnRatio)              ;
                        SRA H                           ;
                        RR L                            ;
                        LD A,H                          ;
                        XOR $80                         ;
                        LD H,A                          ;
                        LD E,(IX+dW_UnkA)               ;
                        LD A,(IX+dW_UnkA+1)             ;
                        XOR $80                         ;
                        LD D,A                          ;
                        SBC HL,DE                       ;
                        RET C                           ;

                        ADD HL,DE                       ;
                        DEC HL                          ;
                        LD E,(IX+dW_UnkC)               ;
                        LD A,(IX+dW_UnkC+1)             ;
                        XOR $80                         ;
                        LD D,A                          ;
                        SBC HL,DE                       ;
                        CCF                             ;
                        RET                             ;

LD476                   LD A,(CurrMapPosition)          ;
                        LD L,A                          ;
                        LD H,high Map                   ;
                        LD A,(optGameFormat)            ;
                        CP $02                          ;
                        LD A,$3F                        ;
                        JR Z LD488                      ;

                        LD A,(HL)                       ;
                        AND $3F                         ;
LD488                   LD (SpaceShipProbability),A     ;

                        XOR A                           ;
                        BIT 6,(HL)                      ;
                        JR Z LD492                      ;

                        LD A,$10                        ;
LD492                   LD (FuelSquareProbability),A    ;

                        INC H                           ;
                        LD A,(HL)                       ;
                        AND $0F                         ;
                        LD (CurrPlanetType),A           ;
                        DEC H                           ;

                        BIT 7,(HL)                      ; Any planets?
                        LD A,$00                        ;
                        JR Z SetPlanetProbability       ; No, clear the probability

                        LD A,(optGameFormat)            ;
                        SUB $03                         ;
                        JR Z SetPlanetProbability       ;

                        LD A,32                         ;
SetPlanetProbability    LD (PlanetProbability),A        ;
                        LD (PlanetProbabilityVal),A     ;

        if false
                        INC H                           ; I think this was intended to make stars denser in certain map sectors
                        LD A,L                          ; but it wasn't used in the game
                        AND $07                         ;
                        BIT 3,L                         ;
                        JR Z LD4BC                      ;

                        XOR $07                         ;
LD4BC                   LD B,A                          ;
                        LD A,L                          ;
                        RRCA                            ;
                        RRCA                            ;
                        RRCA                            ;
                        RRCA                            ;
                        AND $07                         ;
                        BIT 7,L                         ;
                        JR Z LD4CA                      ;

                        XOR $07                         ;
LD4CA                   ADD A,B                         ;
                        ADD A,$0E                       ;
        endif

                        ; Set the number of stars up

                        LD A,30                         ;
                        LD (SpaceInitialnStars),A       ;
                        LD (Stars_nDem),A               ;
                        RET                             ;

;

LD4D6                   LD A,(CurrMapPosition)          ;
                        LD L,A                          ;
                        LD H,high Map                   ;

                        LD A,(SpaceShipProbability)     ;
                        ADD A,A                         ;
                        ADD A,A                         ;
                        LD B,A                          ;

                        LD A,(FuelSquareProbability)    ;
                        CP $01                          ;
                        CCF                             ;
                        RR B                            ;
                        LD A,(PlanetProbability)        ;
                        CP $01                          ;
                        CCF                             ;
                        RR B                            ;

                        LD (HL),B                       ;
                        INC H                           ;
                        LD A,$00                        ;
CurrPlanetType          EQU *-1                         ;
                        AND $0F                         ;
                        LD B,A                          ;
                        LD A,(HL)                       ;
                        AND $F0                         ;
                        OR B                            ;
                        LD (HL),A                       ;

                        RET                             ;

;

LD4FF                   LD A,(GameMode_SPT)             ;
                        OR A                            ;
                        JP Z LD9E5                      ;

                        CP $02                          ;
                        JP Z LD80E                      ;

                        LD HL,$2800                     ;
                        LD DE,(SheetZ)                  ;
                        ADD HL,DE                       ;
                        LD (SheetZ),HL                  ;

                        LD A,$00                        ;
TunnelRequestCnt        EQU *-1                         ;
                        DEC A                           ;
                        JR Z InvokeTunnels              ;

                        LD (TunnelRequestCnt),A         ;

                        LD A,R                          ;
                        RLCA                            ;
                        CP $28                          ;
SpaceShipProbability    EQU *-1                         ;
                        CALL C InvokeAShip              ;

                        CALL Rand                       ;
                        LD A,E                          ;
                        LD R,A                          ;
                        CP $10                          ;
FuelSquareProbability   EQU *-1                         ;
                        CALL C InvokeARefuelSquare      ;

                        CALL Rand                       ;
                        LD A,E                          ;
                        CP $00                          ;
PlanetProbability       EQU *-1                         ;
                        CALL C InvokeAPlanet            ;
                        RET                             ;

;

InvokeTunnels           LD HL,ObjeTable+dObjeFlag       ; Add the tunnels. First we count the free objects
                        LD DE,$0100                     ;
                        LD BC,nObjes*$100               ;
LD544                   LD A,(HL)                       ;
                        CPL                             ;
                        AND $01                         ;
                        ADD A,C                         ;
                        LD C,A                          ;
                        ADD HL,DE                       ;
                        DJNZ LD544                      ;

                        ; Make sure there are enough free objects

                        LD A,C                          ;
                        CP 7                            ;
                        JR C LD5A0                      ; Nope, exit

                        ; Add them in the appropriate directions

                        LD HL,$0000                     ;
                        LD DE,$F000                     ;
                        LD BC,$F000                     ;
                        LD A,(CurrMapPosition)          ;
                        AND $F0                         ;
                        CALL NZ InvokeTunnelMouth       ;

                        LD HL,$0000                     ;
                        LD DE,$1000                     ;
                        LD BC,$1000                     ;
                        LD A,(CurrMapPosition)          ;
                        AND $F0                         ;
                        CP $F0                          ;
                        CALL NZ InvokeTunnelMouth       ;

                        LD HL,-$0C00                    ;
                        LD DE,$0000                     ;
                        LD BC,$FF01                     ;
                        LD A,(CurrMapPosition)          ;
                        AND $0F                         ;
                        CALL NZ InvokeTunnelMouth       ;

                        LD HL,$0C00                     ;
                        LD DE,$0000                     ;
                        LD BC,$0101                     ;
                        LD A,(CurrMapPosition)          ;
                        AND $0F                         ;
                        CP $0F                          ;
                        CALL NZ InvokeTunnelMouth       ;

                        ; Extend the time to next

                        LD A,50                         ;
                        LD (TunnelRequestCnt),A         ;
                        RET                             ;

                ; Request them soon

LD5A0                   LD A,1                          ;
                        LD (TunnelRequestCnt),A         ;
                        RET                             ;

; Add a tunnel mouth

InvokeTunnelMouth       LD (ObjeProto+dObjeX),HL        ;
                        LD (ObjeProto+dObjeY),DE        ;
                        PUSH BC                         ;

                        LD HL,MoveTunnelMouth           ;
                        LD (ObjeProto+dObjepMove),HL    ;

                        LD A,$89                        ;
                        LD (ObjeProto+dObjeFlag),A      ;

                        LD HL,LD3FB                     ;
                        LD (ObjeProto+dObjeCollided),HL ;
                        LD (ObjeProto+dObjeMissed),HL   ;

                        LD HL,Ret                       ;
                        LD (ObjeProto+dObjeShot),HL     ;

                        LD A,$46                        ;
                        LD (ObjeProto+dObjeCol),A       ;

                        CALL FindFreeObje               ;

                        CALL CopyObjectProtoToIY        ;

                        LD (IY+dObjeTimeToNextRecalc),30;

                        POP BC                          ;
                        LD (IY+dObjenShp),B             ;

                        LD HL,$0000                     ;
                        LD DE,$0024                     ;
                        BIT 0,C                         ;
                        JR Z LD5EF                      ;

                        LD HL,$0414                     ;
                        LD DE,$0024                     ;

                        LD (IY+dObjeTimeToNextRecalc),1 ;

LD5EF                   LD (IY+dW_Unk1),HL              ;
                        LD (IY+dW_Unk2),DE              ;
                        LD (IY+dObjeState),1            ;

                        LD A,3                          ;
                        CALL SubSomeStars               ;

                        RET                             ;

; Add a planet

InvokeAPlanet           PUSH AF                         ;
                        CALL FindFreeObje               ;
                        JP C LD6A7                      ;

                        XOR A                           ;
                        LD (PlanetProbability),A        ;

                        LD A,8
                        CALL SubSomeStars

                        LD HL,DrivenIntoPlanet          ;
                        LD (ObjeProto+dObjeCollided),HL ;

                        LD HL,PlanetMissed              ;
                        LD (ObjeProto+dObjeMissed),HL   ;

                        LD HL,Ret                       ;
                        LD (ObjeProto+dObjeShot),HL     ;

                        LD A,$46                        ;
                        LD (ObjeProto+dObjeCol),A       ;

                        LD A,%10001001                  ;
                        LD (ObjeProto+dObjeFlag),A      ;

                        CALL Rand_Signed15bit_DE        ;
                        LD (ObjeProto+dObjeX),DE        ;

                        CALL Rand_Signed15bit_DE        ;
                        LD (ObjeProto+dObjeY),DE        ;

                        LD HL,MoveObje_X2               ;
                        LD (ObjeProto+dObjepMove),HL    ;

                        CALL CopyObjectProtoToIY        ;

                        LD (IY+dObjeState),1            ;

                        POP AF                          ;
                        RET                             ;

InvokeARefuelSquare     PUSH AF                         ;
                        CALL FindFreeObje               ;
                        JR C LD6A7                      ;

                        XOR A                           ;
                        LD (FuelSquareProbability),A    ;

                        LD HL,MoveObje_X3               ;
                        LD (ObjeProto+dObjepMove),HL    ;

                        LD A,$45                        ;
                        LD (ObjeProto+dObjeCol),A       ;

                        LD HL,LD390                     ;
                        LD (ObjeProto+dObjeCollided),HL ;

                        LD HL,LD3C9                     ;
                        LD (ObjeProto+dObjeMissed),HL   ;

                        LD HL,Ret                       ;
                        LD (ObjeProto+dObjeShot),HL     ;

                        CALL Rand_Signed15bit_DE        ;
                        LD (ObjeProto+dObjeX),DE        ;

                        CALL Rand_Signed15bit_DE        ;
                        LD (ObjeProto+dObjeY),DE        ;

                        LD A,%10001001                  ;
                        LD (ObjeProto+dObjeFlag),A      ;

                        CALL CopyObjectProtoToIY        ;

                        LD (IY+dObjedZ+1),1             ;
                        LD (IY+dObjeState),1            ;
                        LD (IY+dObjeTimeToNextRecalc),1 ;
                        LD (IY+dW_Unk1),$00             ;
                        LD (IY+dW_Unk1+1),$00           ;
                        LD (IY+dW_Unk2),$24             ;
                        LD (IY+dW_Unk2+1),$00           ;

LD6A7                   POP AF                          ;
                        RET                             ;

;

InvokeAShip             PUSH AF                         ;
                        CALL FindFreeObje               ;
                        JR C LD70C                      ;

                        LD A,(SpaceShipProbability)     ;
                        SUB $03                         ;
                        JP P LD6B8                      ;

                        XOR A                           ;
LD6B8                   LD (SpaceShipProbability),A     ;

                        LD A,4                          ;
                        CALL SubSomeStars               ;

                        ; This code was bugged. It should have started the ships positioned randomly, but it didn't, not properly.

        if enabled bDontFixBug
                        CALL Rand_Signed15bit_DE        ;
                        LD (ObjeProto+dObjeX),HL        ;

                        CALL Rand_Signed15bit_DE        ;
                        LD (ObjeProto+dObjeY),HL        ;
        else
                        CALL Rand_Signed15bit_DE        ;
                        LD (ObjeProto+dObjeX),DE        ; Was HL

                        CALL Rand_Signed15bit_DE        ;
                        LD (ObjeProto+dObjeY),DE        ; Was HL
        endif

                        LD HL,Table_8x_ShipMoves        ;
                        CALL GetRandomFromTab8w         ;
                        LD (ObjeProto+dObjepMove),HL    ;

                        LD A,%10011111                  ;
                        LD (ObjeProto+dObjeFlag),A      ;

                        LD HL,SpaceshipShot             ;
                        LD (ObjeProto+dObjeShot),HL     ;

                        LD HL,SpaceshipCollision        ;
                        LD (ObjeProto+dObjeCollided),HL ;

                        LD HL,SpaceshipMissed           ;
                        LD (ObjeProto+dObjeMissed),HL   ;

                        LD A,$45                        ;
                        LD (ObjeProto+dObjeCol),A       ;

                        CALL CopyObjectProtoToIY        ;
                        LD (IY+dObjeState),1            ;
                        LD A,R                          ;
                        AND $1F                         ;
                        CP $0F                          ;
                        JR NC LD705                     ;

                        CALL LD722                      ;
                        POP AF                          ;
                        RET                             ;

;

LD705                   PUSH IY                         ;
                        POP IX                          ;
                        CALL RecalcShipMove             ;
LD70C                   POP AF                          ;
                        RET                             ;

;

Rand_Signed15bit_DE     CALL Rand                       ;
                        SRA D                           ;
                        RR E                            ;
                        RET                             ;

;

LD71C                   LD DE,$2000                     ;
                        JP SignDiv                      ;

LD722                   CALL Rand_Signed15bit_DE        ;
                        LD (LD74B),DE                   ;

                        LD L,E                          ;
                        LD H,D                          ;
                        BIT 7,H                         ;
                        CALL NZ NegHL                   ;
                        LD (LD770),HL                   ;

                        LD L,E                          ;
                        LD H,D                          ;
                        LD A,R                          ;
                        AND $08                         ;
                        CALL Z NegHL                    ;
                        LD (LD75E),HL                   ;

                        LD A,R                          ;
                        AND $02                         ;
                        CALL NZ LD7D7                   ;

                        CALL Rand_Signed15bit_DE        ;
                        EX DE,HL                        ;

                        LD DE,$0000                     ;
LD74B                   EQU *-2                         ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        CALL LD71C                      ;
                        LD (IY+dObjedX),HL              ;

                        CALL Rand_Signed15bit_DE        ;
                        EX DE,HL                        ;
                        LD DE,$0000                     ;
LD75E                   EQU *-2                         ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        CALL LD71C                      ;
                        LD (IY+dObjedY),HL              ;

                        LD HL,$8000                     ;
                        LD DE,$0000                     ;
LD770                   EQU *-2                         ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        CALL LD71C                      ;
                        LD (IY+dObjedZ),HL

                        LD HL,(LD74B)
                        LD (IY+dObjeX),HL
                        LD HL,(LD75E)
                        LD (IY+dObjeY),HL
                        LD HL,(LD770)
                        LD (IY+dObjeZ),HL

                        LD (IY+dObjeTimeToNextRecalc),32

                        LD DE,(IY+dObjedX)
                        LD HL,(IY+dObjeX)
                        ADD HL,DE
                        LD (IY+dObjeX),HL

                        LD DE,(IY+dObjedY)
                        LD HL,(IY+dObjeY)
                        ADD HL,DE
                        LD (IY+dObjeY),HL

                        LD DE,(IY+dObjedZ)
                        LD HL,(IY+dObjeZ)
                        ADD HL,DE
                        LD (IY+dObjeZ),HL

                        RET

LD7D7                   LD HL,(LD74B)                   ;
                        LD DE,(LD75E)                   ;
                        LD (LD75E),HL                   ;
                        LD (LD74B),DE                   ;
                        RET                             ;

GetRandomFromTab8w      PUSH HL                         ;
                        CALL Rand                       ;
                        POP HL                          ;
                        LD A,E                          ;
                        AND $0E                         ;
                        ADD A,L                         ;
                        LD L,A                          ;
                        LD A,H                          ;
                        ADC A,$00                       ;
                        LD H,A                          ;
                        LD A,(HL)                       ;
                        INC HL                          ;
                        LD H,(HL)                       ;
                        LD L,A                          ;
                        RET                             ;

LD80E                   LD HL,(SheetZ)                  ;
                        LD DE,$1600                     ;
                        ADD HL,DE                       ;
                        LD (SheetZ),HL                  ;

                        JP Ret                          ;
LD819                   EQU *-2                         ;

;

LD81B                   CALL FindFreeObje               ;
                        LD HL,MoveObje_X4               ;
                        LD (ObjeProto+dObjepMove),HL    ;
                        LD HL,Ret                       ;
                        LD (ObjeProto+dObjeShot),HL     ;
                        CALL CopyObjectProtoToIY        ;
                        CALL LD951                      ;

                        ; Had enough to start doing damage?

                        LD A,$00                        ;
TunnelObjeCnt           EQU *-1                         ;
                        DEC A                           ;
                        JP Z LD84F                      ;

                        LD (TunnelObjeCnt),A            ;

                        LD HL,$0000                     ;
LD83A                   EQU *-2                         ;
                        LD DE,$0000                     ;
LD83D                   EQU *-2                         ;
                        ADD HL,DE                       ;
                        LD (LD83A),HL                   ;

                        LD HL,$0000                     ;
LD844                   EQU *-2                         ;
                        LD DE,$0000                     ;
LD847                   EQU *-2                         ;
                        ADD HL,DE                       ;
                        LD (LD844),HL                   ;

                        JR LD857                        ;

;

LD84F                   LD (IY+dObjeMissed),low CauseDamageToPlayer
                        LD (IY+dObjeMissed+1),high CauseDamageToPlayer

LD857                   LD A,(TunnelSegmentCount)       ;
                        DEC A                           ;
                        LD (TunnelSegmentCount),A       ;
                        JR NZ TunnelNextSegment         ;

                        LD IX,(pTunnelDefn)             ;
                        LD A,(IX +8)                    ;
                        OR A                            ;
                        JR NZ LD87F                     ;

                        LD A,(TunnelSectionCount)       ;
                        DEC A                           ;
                        LD (TunnelSectionCount),A       ;
                        JR Z TunnelEnd                  ;

                        CALL TunnelSetup                ;
                        LD (pTunnelDefn),HL             ;

                        PUSH HL                         ;
                        POP IX                          ;

                        LD A,(IX +8)                    ;
LD87F                   LD (TunnelSegmentCount),A       ;

                        LD L,(IX)                       ;
                        LD H,(IX +1)                    ;
                        LD (LD9D7),HL                   ;
                        LD L,(IX +2)                    ;
                        LD H,(IX +3)                    ;
                        LD (LD9D9),HL                   ;
                        LD L,(IX +4)                    ;
                        LD H,(IX +5)                    ;
                        LD (LD9DE),HL                   ;
                        LD L,(IX +6)                    ;
                        LD H,(IX +7)                    ;
                        LD (LD9E0),HL                   ;

                        LD BC,$000A                     ;
                        ADD IX,BC                       ;

                        LD (pTunnelDefn),IX             ;

                        CALL Ret                        ;
LD8B0                   EQU *-2                         ;

TunnelNextSegment       LD HL,(LD9DE)                   ;
                        LD DE,(LD9D7)                   ;
                        ADD HL,DE                       ;
                        LD (LD9D7),HL                   ;

                        LD DE,(LD9D3)                   ;
                        ADD HL,DE                       ;
                        LD (LD9D3),HL                   ;

                        LD DE,(GroundX)                 ;
                        ADD HL,DE                       ;
                        LD (IY+dObjeX),HL               ;

                        LD HL,(LD9E0)                   ;
                        LD DE,(LD9D9)                   ;
                        ADD HL,DE                       ;
                        LD (LD9D9),HL                   ;

                        LD DE,(LD9D5)                   ;
                        ADD HL,DE                       ;
                        LD (LD9D5),HL                   ;

                        LD DE,(GroundY)                 ;
                        ADD HL,DE                       ;
                        LD (IY+dObjeY),HL               ;

                        RET                             ;

TunnelEnd               LD HL,LD900                     ;
                        LD (LD819),HL                   ;

                        LD HL,$0000                     ;
                        LD (LD9DE),HL                   ;
                        LD (LD9E0),HL                   ;

                        JR LD938                        ;

LD900                   LD HL,(LD83A)                   ;
                        LD DE,(LD83D)                   ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (LD83A),HL                   ;

                        LD HL,(LD844)                   ;
                        LD DE,(LD847)                   ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (LD844),HL                   ;

                        ; Count down to exit

                        LD A,(TunnelObjeCnt)            ;
                        INC A                           ;
                        CP $08                          ;
                        JR Z LD93E                      ;

                        LD (TunnelObjeCnt),A            ;

                        CALL FindFreeObje               ;
                        RET C                           ;

                        LD HL,Ret                       ;
                        LD (ObjeProto+dObjeShot),HL     ;

                        LD HL,MoveObje_X4               ;
                        LD (ObjeProto+dObjepMove),HL    ;

                        CALL CopyObjectProtoToIY        ;

LD938                   CALL LD951                      ;

                        JP TunnelNextSegment            ;

LD93E                   LD HL,LD94B                     ;
                        LD (LD819),HL                   ;
                        LD HL,LDC00                     ;
                        LD (SheetZ),HL                  ;
                        RET                             ;

LD94B                   LD A,$03                        ;
                        LD (GameState),A                ;
                        RET                             ;

;

LD951                   LD HL,(LD844)                   ;
                        LD (IY+dW_Unk2),HL              ;

                        LD HL,(LD83A)                   ;
                        LD (IY+dW_Unk1),HL              ;

                        LD (IY+dObjeFlag),1             ;

                        LD A,R                          ;
                        AND $03                         ;
                        OR $44                          ;
                        CP $46                          ;
                        JR C LD973                      ;

                        AND $0F                         ;
LD973                   LD (IY+dObjeCol),A              ;
                        LD (IY+dObjeState),1            ;
                        RET                             ;

; This randomly inverts x/y a vector and selects a pointer to something or other
; Tunnel setup?

TunnelSetup             LD A,(Rand)                     ;
                        AND $03                         ;
                        ADD A,A                         ;
                        LD E,A                          ;
                        LD D,0                          ;

                        LD HL,LD9A0                     ;
                        ADD HL,DE                       ;

                        LD A,(HL)                       ;
                        INC HL                          ;
                        LD H,(HL)                       ;
                        LD L,A                          ;
                        LD (LD8B0),HL                   ;

                        LD A,R                          ;
                        AND $0F                         ;
                        ADD A,A                         ;
                        LD E,A                          ;
                        LD D,0                          ;

                        LD HL,TunnelTypeTable
                        ADD HL,DE                       ;

                        LD A,(HL)                       ;
                        INC HL                          ;
                        LD H,(HL)                       ;
                        LD L,A                          ;
                        RET                             ;

LD9A0                   DEFW Ret,LD9A8,LD9BE,LD9BB      ;

LD9A8                   LD HL,(LD9D7)                   ;
                        mNegHL()                        ;
                        LD (LD9D7),HL                   ;
                        LD HL,(LD9DE)                   ;
                        mNegHL()                        ;
                        LD (LD9DE),HL                   ;
                        RET                             ;

LD9BB                   CALL LD9A8                      ;
LD9BE                   LD HL,(LD9D9)                   ;
                        mNegHL()                        ;
                        LD (LD9D9),HL                   ;
                        LD HL,(LD9E0)                   ;
                        mNegHL()                        ;
                        LD (LD9E0),HL                   ;
                        RET                             ;

;

GroundX                 DEFW 0
LD9D3                   DEFW 0
LD9D5                   DEFW 0
LD9D7                   DEFW 0
LD9D9                   DEFW 0
TunnelSegmentCount      DEFB 1

pTunnelDefn             DEFW 0
LD9DE                   DEFW 0
LD9E0                   DEFW 0
TunnelSectionCount      DEFB 0

;

LD9E5                   LD HL,(SheetZ)                  ;
                        LD DE,$2800                     ;
                        ADD HL,DE                       ;
                        LD (SheetZ),HL                  ;

                        LD HL,LDA11                     ;
                        PUSH HL                         ;
                        LD HL,(LDA61)                   ;
                        LD H,high MapOfPlanet           ;
                        LD (LD2B9),HL                   ;

                        LD A,(HL)                       ;
                        AND $F0                         ;
                        JP Z LDAB6                      ;

                        CP $10                          ;
                        JP Z LDBF9                      ;

                        CP $20                          ;
                        JP Z LDC0F                      ;

                        CP $30                          ;
                        JP Z LDBE3                      ;

                        POP HL                          ;
LDA11                   LD A,$00                        ;
LDA12                   EQU *-1                         ;
                        DEC A                           ;
                        LD (LDA12),A                    ;
                        RET NZ                          ;

                        LD HL,LC593                     ;
                        LD (LDBE4),HL                   ;

                        LD HL,LC5C5                     ;
                        LD (LDBFA),HL                   ;

                        LD HL,LC61E                     ;
                        LD (LDC10),HL                   ;

                        LD A,$10                        ;
                        LD (LDA12),A                    ;

                        LD HL,$0000                     ;
                        LD (GroundX),HL                 ;

                        LD HL,(LC9F5)                   ;
                        LD DE,$0000                     ;
                        LD (LC9F3),DE                   ;
                        LD (LC9F5),DE                   ;
                        LD B,$FF                        ;
                        LD A,L                          ;
                        BIT 7,H                         ;
                        JR Z LDA4D                      ;

                        LD B,$01                        ;
                        CPL                             ;
LDA4D                   CP $01                          ;
                        JR NC LDA53                     ;

                        LD B,$00                        ;
LDA53                   LD A,$00                        ;
ArrowDirn               EQU *-1                         ;
                        ADD A,B                         ;
                        AND $07                         ;
                        LD (ArrowDirn),A                ;

                        PUSH AF                         ;
                        CALL LD0AD                      ;
                        POP AF                          ;

                        LD B,$00                        ;
LDA61                   EQU *-1                         ;
                        CP $03                          ;
                        CALL C LDA8B                    ;
                        CP $02                          ;
                        JR C LDA70                      ;

                        CP $05                          ;
                        CALL C LDAAF                    ;
LDA70                   CP $04                          ;
                        JR C LDA85                      ;

                        CP $07                          ;
                        CALL C LDA99                    ;
                        CP $06                          ;
                        JR C LDA80                      ;

                        CALL LDAA8                      ;
LDA80                   LD A,B                          ;
                        LD (LDA61),A                    ;
                        RET                             ;

LDA85                   OR A                            ;
                        CALL Z LDAA8                    ;
                        JR LDA80                        ;

LDA8B                   EX AF,AF'                       ;
                        LD A,B                          ;
                        INC A                           ;
                        LD B,A                          ;
                        AND $0F                         ;
                        JR NZ LDA97                     ;

                        LD A,B                          ;
                        SUB $10                         ;
                        LD B,A                          ;
LDA97                   EX AF,AF'                       ;
                        RET                             ;

LDA99                   EX AF,AF'                       ;
                        LD A,B                          ;
                        DEC A                           ;
                        LD B,A                          ;
                        OR $F0                          ;
                        INC A                           ;
                        JR NZ LDAA6                     ;

                        LD A,B                          ;
                        ADD A,$10                       ;
                        LD B,A                          ;
LDAA6                   EX AF,AF'                       ;
                        RET                             ;

LDAA8                   EX AF,AF'                       ;
                        LD A,B                          ;
                        SUB $10                         ;
                        LD B,A                          ;
                        EX AF,AF'                       ;
                        RET                             ;

LDAAF                   EX AF,AF'                       ;
                        LD A,B                          ;
                        ADD A,$10                       ;
                        LD B,A                          ;
                        EX AF,AF'                       ;
                        RET                             ;

LDAB6                   LD A,(HL)                       ;
                        OR A                            ;
                        RET Z                           ;

                        DEC A                           ;
                        JR Z LDACE                      ;

                        DEC A                           ;
                        JR Z LDB11                      ;

                        DEC A                           ;
                        JP Z LDB87                      ;

                        DEC A                           ;
                        JP Z LDBA1                      ;

                        DEC A                           ;
                        JP Z LDBBA                      ;

                        JP LDBD3                        ;

;

LDACE                   CALL Rand_Signed15bit_DE        ;
                        LD (ObjeProto+dObjeX),DE        ;
LDAD5                   LD HL,ObjeTriangleTower         ;
                        LD A,R                          ;
                        AND $01                         ;
                        JR Z LDAE1                      ;

                        LD HL,DrawSquareTower           ;
LDAE1                   LD (ObjeProto+dObjepMove),HL    ;
                        LD A,$0F                        ;
                        LD (ObjeProto+dObjeFlag),A      ;
                        LD A,$1E                        ;
                        LD (ObjeProto+dObjeCnt),A       ;
                        LD HL,TowerShot                 ;
                        LD (ObjeProto+dObjeShot),HL     ;
                        LD HL,SomeObjectMissed          ;
                        LD (ObjeProto+dObjeMissed),HL   ;
                        LD HL,SomeObjectHit             ;
                        LD (ObjeProto+dObjeCollided),HL ;
                        LD A,R                          ;
                        AND $03                         ;
                        ADD A,$44                       ;
                        LD (ObjeProto+dObjeCol),A       ;
                        CALL CreateObjeOnGround         ;

                        LD A,4
                        JP SubSomeStars

;

LDB11                   LD HL,$0400                     ;
                        LD DE,$0500                     ;
                        EXX                             ;
                        LD A,$00                        ;
LDB19                   EQU *-1                         ;
                        INC A                           ;
                        LD (LDB19),A                    ;
                        AND $01                         ;
                        JR Z LDACE                      ;

LDB22                   CALL Rand_Signed15bit_DE        ;
                        SRA D                           ;
                        RR E                            ;
                        SRA D                           ;
                        RR E                            ;
                        LD (ObjeProto+dObjeX),DE        ;
LDB31                   LD (LDB99),DE                   ;
                        LD HL,MoveObje_X6               ;
                        LD (ObjeProto+dObjepMove),HL    ;
                        EXX                             ;
                        LD (ObjeProto+dW_Unk1),HL       ;
                        LD (ObjeProto+dW_Unk2),DE       ;
                        LD A,$0D                        ;
                        LD (ObjeProto+dObjeFlag),A      ;
                        LD A,$14                        ;
                        LD (ObjeProto+dObjeCnt),A       ;
                        LD HL,ForceFieldMissed          ;
                        LD (ObjeProto+dObjeMissed),HL   ;
                        LD HL,LD369                     ;
                        LD (ObjeProto+dObjeCollided),HL ;
                        LD A,R                          ;
                        AND $03                         ;
                        ADD A,$44                       ;
                        LD (ObjeProto+dObjeCol),A       ;
                        LD HL,Ret                       ;
                        LD (ObjeProto+dObjeShot),HL     ;
                        CALL CreateObjeOnGround         ;
                        RET C                           ;

                        LD (IY+dObjeFlag),%00101001     ;
                        LD (IY+dObjeState),1            ;
                        LD HL,(GroundY)                 ;
                        LD DE,$F830                     ;
                        ADD HL,DE                       ;
                        LD (IY+dObjeY),HL               ;

                        LD A,2                          ;
                        CALL SubSomeStars               ;

                        RET                             ;

;

LDB87                   LD HL,$0200                     ;
                        LD DE,$0300                     ;
                        EXX                             ;
                        LD A,$00                        ;
LDB8F                   EQU *-1                         ;
                        INC A                           ;
                        LD (LDB8F),A                    ;
                        AND $01                         ;
                        JR Z LDB22                      ;

                        LD HL,$0000                     ;
LDB99                   EQU *-2                         ;
                        LD (ObjeProto+dObjeX),HL        ;
                        JP LDAD5                        ;

LDBA1                   LD A,$00                        ;
LDBA2                   EQU *-1                         ;
                        INC A                           ;
                        LD (LDBA2),A                    ;
                        AND $01                         ;
                        RET Z                           ;

                        LD HL,$0180                     ;
                        LD DE,$0200                     ;
                        EXX                             ;
                        CALL LDB22                      ;
                        RET C                           ;

                        LD (IY+dObjeFlag),%00001111     ;
                        RET                             ;

;

LDBBA                   LD A,$00                        ;
LDBBB                   EQU *-1                         ;
                        INC A                           ;
                        LD (LDBBB),A                    ;
                        AND $01                         ;
                        RET Z                           ;

                        LD HL,$0100                     ;
                        LD DE,$0140                     ;
                        EXX                             ;
                        CALL LDB22                      ;
                        RET C                           ;

                        LD (IY+dObjeFlag),%00001111     ;
                        RET                             ;

LDBD3                   LD HL,$0100                     ;
                        LD DE,$0140                     ;
                        EXX                             ;
                        CALL LDB22                      ;
                        RET C                           ;

                        LD (IY+dObjeFlag),%00001111     ;
                        RET                             ;

;

LDBE3                   LD HL,$0000                     ;
LDBE4                   EQU *-2                         ;
LDBE6                   LD A,(HL)                       ;
                        OR A                            ;
                        JR Z LDBF4                      ;

                        INC HL                          ;
                        LD E,(HL)                       ;
                        INC HL                          ;
                        LD D,(HL)                       ;
                        INC HL                          ;

                        CALL AddObje_A_DEisX            ;

                        JR LDBE6                        ;

LDBF4                   INC HL                          ;
                        LD (LDBE4),HL                   ;
                        RET                             ;

LDBF9                   LD HL,$0000                     ;
LDBFA                   EQU *-2                         ;
LDBFC                   LD A,(HL)                       ;
                        OR A                            ;
                        JR Z LDC0A                      ;

LDC00                   INC HL                          ;
                        LD E,(HL)                       ;
                        INC HL                          ;
                        LD D,(HL)                       ;
                        INC HL                          ;

                        CALL AddObje_A_DEisX            ;

                        JR LDBFC                        ;

LDC0A                   INC HL                          ;
                        LD (LDBFA),HL                   ;
                        RET                             ;

LDC0F                   LD HL,$0000                     ;
LDC10                   EQU *-2                         ;
LDC12                   LD A,(HL)                       ;
                        OR A                            ;
                        JR Z LDC20                      ;

                        INC HL                          ;
                        LD E,(HL)                       ;
                        INC HL                          ;
                        LD D,(HL)                       ;
                        INC HL                          ;

                        CALL AddObje_A_DEisX            ;

                        JR LDC12                        ;

LDC20                   INC HL                          ;
                        LD (LDC10),HL                   ;
                        RET                             ;

; Add an object to a base tower

AddObje_A_DEisX         PUSH HL                         ;

                        LD HL,(GroundX)                 ;
                        ADD HL,DE                       ;
                        LD (ObjeProto+dObjeX),HL        ;

                        DEC A                           ;
                        JR Z AddObje0                   ; 1

                        DEC A                           ;
                        JR Z AddObjeCyanSqTower_S       ; 2 (Small cyan sq tower)

                        DEC A                           ;
                        JR Z AddObjeYellTriTower_S      ; 3 (Small yellow tri tower)

                        DEC A                           ;
                        JR Z AddObje3                   ; 4

                        DEC A                           ;
                        JP Z AddObje4                   ; 5 (Force-field hole, random colour?)

                        DEC A                           ;
                        JP Z AddObje5                   ; 6

                        DEC A                           ;
                        JR Z AddObje6                   ; 7 (Tall white sq tower)

                        DEC A                           ;
                        JR Z AddObje7                   ; 8

                        DEC A                           ;
                        JR Z AddPlanetBasedSpaceship    ; 9

                        DEC A                           ;
                        JP Z AddObje9                   ; 10

                        ; If we get here we're screwed

                        DI                              ;
                        JP RestartEntireGame            ; Restart the game

AddObje0                LD A,$14                        ;
                        LD (ObjeProto+dObjeCnt),A       ;
                        LD A,$45                        ;
                        LD (ObjeProto+dObjeCol),A       ;
                        LD HL,ObjeTriangleTower         ;
                        JP CreateObject_HLonStack       ;

AddObjeCyanSqTower_S    LD A,$14                        ;
                        LD (ObjeProto+dObjeCnt),A       ;
                        LD A,$45                        ;
                        LD (ObjeProto+dObjeCol),A       ;
                        LD HL,DrawSquareTower           ;
                        JP CreateObject_HLonStack       ;

AddObjeYellTriTower_S   LD A,$28                        ;
                        LD (ObjeProto+dObjeCnt),A       ;
                        LD A,$46                        ;
                        LD (ObjeProto+dObjeCol),A       ;
                        LD HL,ObjeTriangleTower         ;
                        JP CreateObject_HLonStack       ;

AddObje3                LD A,$28                        ;
                        LD (ObjeProto+dObjeCnt),A       ;
                        LD A,$46                        ;
                        LD (ObjeProto+dObjeCol),A       ;
                        LD HL,DrawSquareTower           ;
                        JP CreateObject_HLonStack       ;

AddObje6                LD A,$3C                        ;
                        LD (ObjeProto+dObjeCnt),A       ;
                        LD A,$47                        ;
                        LD (ObjeProto+dObjeCol),A       ;
                        LD HL,ObjeTriangleTower         ;
                        JP CreateObject_HLonStack       ;

AddObje7                LD A,$3C                        ;
                        LD (ObjeProto+dObjeCnt),A       ;
                        LD A,$47                        ;
                        LD (ObjeProto+dObjeCol),A       ;
                        LD HL,DrawSquareTower           ;
                        JP CreateObject_HLonStack       ;

;

AddPlanetBasedSpaceship LD A,40                         ;
                        LD (ObjeProto+dObjeCnt),A       ;

                        LD A,$47                        ;
                        LD (ObjeProto+dObjeCol),A       ;

                        LD HL,PlanetsShipMoveRoutine    ;
                        CALL CreateAnObject             ;
                        JR C PopHL_Ret                  ;

                        LD (IY+dObjeFlag),%10001111     ;

                        LD HL,SpaceportShipShot         ;
                        LD (IY+dObjeShot),HL            ;

                        LD HL,SpaceshipCollision        ;
                        LD (IY+dObjeCollided),HL        ;

                        LD HL,SpaceshipMissed           ;
                        LD (IY+dObjeMissed),HL          ;

                        PUSH IY                         ;
                        POP IX                          ;
                        CALL RecalcShipMove             ;
PopHL_Ret               POP HL                          ;
                        RET                             ;

;

AddObje9                CALL FindFreeObje               ;
                        JR C PopHL_Ret                  ;

                        LD HL,MoveObje_X3               ;
                        LD (ObjeProto+dObjepMove),HL    ;

                        LD A,$45                        ;
                        LD (ObjeProto+dObjeCol),A       ;

                        LD HL,LD3AA                     ;
                        LD (ObjeProto+dObjeCollided),HL ;

                        LD HL,Ret                       ;
                        LD (ObjeProto+dObjeMissed),HL   ;
                        LD (ObjeProto+dObjeShot),HL     ;

                        LD HL,(GroundY)                 ;
                        LD DE,$F800                     ;
                        ADD HL,DE                       ;
                        LD (ObjeProto+dObjeY),HL        ;

                        LD A,$89
                        LD (ObjeProto+dObjeFlag),A      ;
                        CALL CopyObjectProtoToIY        ;

                        LD (IY+dObjeState),1            ;
                        LD (IY+dObjeTimeToNextRecalc),1 ;
                        LD (IY+dW_Unk1),$00             ;
                        LD (IY+dW_Unk1+1),$00           ;
                        LD (IY+dW_Unk2),$24             ;
                        LD (IY+dW_Unk2+1),$00           ;
                        POP HL                          ;
                        RET                             ;

;

PlanetsShipMoveRoutine  CALL Ret                        ;

                        ; Clear dY

                        LD HL,$0000                     ;
                        LD (IX+dObjedY),HL              ;
                        RET                             ;

AddObje4                LD HL,$0400                     ;
                        LD DE,$0500                     ;
                        EXX                             ;
                        CALL LDB31                      ;
                        POP HL                          ;
                        RET                             ;

AddObje5                LD HL,(ObjeProto+dObjeX)        ;
                        PUSH HL                         ;
                        LD DE,$FD00                     ;
                        ADD HL,DE                       ;
                        LD (ObjeProto+dObjeX),HL        ;

                        LD A,$3C                        ;
                        LD (ObjeProto+dObjeCnt),A       ;

                        LD A,$47                        ;
                        LD (ObjeProto+dObjeCol),A       ;

                        LD HL,ObjeTriangleTower         ;
                        CALL CreateAnObject             ;
                        JR C LDDB3                      ;

                        LD (IY+dObjeZ+1),$7C            ;
                        POP HL                          ;
                        PUSH HL                         ;
                        LD DE,$0300                     ;
                        ADD HL,DE                       ;
                        LD (ObjeProto+dObjeX),HL        ;
                        LD A,$3C                        ;
                        LD (ObjeProto+dObjeCnt),A       ;

                        LD HL,ObjeTriangleTower         ;
                        CALL CreateAnObject             ;
                        JR C LDDB3                      ;

                        LD (IY+dObjeZ+1),$7C            ;
                        POP HL                          ;
                        LD (ObjeProto+dObjeX),HL        ;
                        LD A,$64                        ;
                        LD (ObjeProto+dObjeCnt),A       ;

                        LD HL,ObjeTriangleTower         ;
                        CALL CreateAnObject             ;
                        JR C LDDB4                      ;

                        LD (IY+dObjeZ+1),$78            ;

                        LD A,20                         ;
                        LD (ObjeProto+dObjeCnt),A       ;

                        LD HL,DrawSquareTower           ;
                        LD (ObjeProto+dObjepMove),HL    ;

                        LD HL,LD296                     ;
                        LD (ObjeProto+dObjeShot),HL     ;
                        JR LDDC3                        ;

;

LDDB3                   POP HL                          ;
LDDB4                   POP HL                          ;
                        RET                             ;

;
CreateAnObject          PUSH HL                         ;

CreateObject_HLonStack  LD (ObjeProto+dObjepMove),HL    ;

                        LD HL,TowerShot                 ;
                        LD (ObjeProto+dObjeShot),HL     ;

                        LD HL,SomeObjectMissed          ;
LDDC3                   LD (ObjeProto+dObjeMissed),HL   ;

                        LD HL,SomeObjectHit             ;
                        LD (ObjeProto+dObjeCollided),HL ;

                        LD A,%00001111                  ;
                        LD (ObjeProto+dObjeFlag),A      ;

                        CALL CreateObjeOnGround         ;
                        JR C CreateObject_X             ;

                        LD A,4                          ;
                        CALL SubSomeStars               ;

                        OR A                            ;

CreateObject_X          POP HL                          ;
                        RET                             ;

; Create an object on the ground

CreateObjeOnGround      CALL FindFreeObje               ;
                        RET C                           ;

                        LD HL,(GroundY)                 ;
                        LD (ObjeProto+dObjeY),HL        ;

                        CALL CopyObjectProtoToIY        ;

                        OR A                            ;
                        RET                             ;

KillAllObjects          LD HL,ObjeTable+dObjeFlag       ;
                        LD DE,$0100                     ;
                        LD B,nObjes                     ;
KAO_Lp                  LD (HL),$00                     ;
                        ADD HL,DE                       ;
                        DJNZ KAO_Lp                     ;

                        RET                             ;

CopyObjectProtoToIY     LD HL,ObjeProto                 ;

                        PUSH IY                         ;
                        POP DE                          ;

                        LD BC,$0050                     ;
                        LDIR                            ;
                        RET                             ;

ShowObjects             LD IX,ObjeTable                 ;
                        LD B,nObjes                     ;

ShowObjects_Lp          PUSH BC                         ;

                        BIT 0,(IX+dObjeFlag)            ; Alive?
                        JP Z ShowObjects_Next           ; No, skip

                        LD A,(IX+dObjeCol)              ;
                        LD (Colour),A                   ;

                        LD HL,(IX+dObjeX)               ;
                        LD (IX+dObjeOldX),H             ;
                        LD BC,(DeltaX)                  ;
                        ADD HL,BC                       ;
                        LD BC,(IX+dObjedX)              ;
                        ADD HL,BC                       ;
                        LD (IX+dObjeX),HL               ;
                        LD (TempX),HL                   ;

                        LD HL,(IX+dObjeY)               ;
                        LD (IX+dObjeOldY),H             ;
                        LD BC,(DeltaY)                  ;
                        ADD HL,BC                       ;
                        LD BC,(IX+dObjedY)              ;
                        ADD HL,BC                       ;
                        LD (IX+dObjeY),HL               ;
                        LD (TempY),HL                   ;

                        LD HL,(IX+dObjeZ)               ;
                        LD (IX+dObjeOldZ),H             ;
                        LD BC,(DeltaZ)                  ;
                        ADD HL,BC                       ;
                        LD BC,(IX+dObjedZ)              ;
                        ADD HL,BC                       ;
                        LD (IX+dObjeZ),HL               ;
                        LD (TempZ),HL                   ;

                        ; Behind us?

                        BIT 7,(IX+dObjeZ+1)             ;
                        JP NZ LDF38                     ;

                        LD DE,$FE00                     ;
                        ADD HL,DE                       ;
                        JP NC LDF64                     ;

                        LD A,$00                        ;
nMissiles               EQU *-1                         ;
                        CP $02                          ;
                        JR Z LDE98                      ;

                        BIT 1,(IX+dObjeFlag)            ; Can fire?
                        JR Z LDE98                      ;

                        ; Randomly fire at the player

                        LD A,R                          ;
                        AND $3F                         ;
                        CP $3F                          ;
optSkillLevel_C         EQU *-1                         ;

                        CALL C FireAtPlayer             ;

LDE98                   LD A,(IX+dObjeState)            ;
                        OR A                            ;
                        JR Z LDECF                      ;

                        DEC A                           ;
                        JR Z LDEF3                      ;

                        CP $FE                          ;
                        JP Z LDEC9                      ;

                        DEC A                           ;
                        JR NZ LDEF3                     ;

                        LD HL,(IX+dObjeY)               ;
                        LD DE,(IX+dObjeDY)              ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD (IX+dObjeY),HL               ;
                        LD DE,(GroundY)                 ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        BIT 7,H                         ;
                        JR NZ LDEF3                     ;

LDEC9                   RES 0,(IX+dObjeFlag)            ;
                        JR ShowObjects_Undraw           ;

LDECF                   DEC (IX+dObjeCnt)               ;
                        JR Z LDEE9                      ;

                        LD HL,(IX+dObjeY)               ;
                        LD DE,(IX+dObjeDY)              ;
                        ADD HL,DE                       ;
                        LD (IX+dObjeY),HL               ;
                        JR LDEF3                        ;

LDEE9                   INC (IX+dObjeState)             ;

                        XOR A                           ;
                        LD (IX+dObjeDY),A               ;
                        LD (IX+dObjeDY+1),A             ;

LDEF3                   LD A,(IX+dObjeZ+1)              ; Is it behind us?
                        CP $7E                          ;
                        JR NC ShowObjects_Next          ;

                        LD HL,(IX+dObjepMove)           ;
                        CALL CallHL                     ;

                        JR C ShowObjects_NotDrawn       ;

                        RES 0,(IX+dObjeFlag)            ;
                        LD HL,(IX+dObjeMissed)          ;
                        CALL CallHL                     ;

ShowObjects_Undraw      PUSH IX                         ;
                        POP IY                          ;
                        LD BC,dObjeLines                ;
                        ADD IY,BC                       ;
                        PUSH IY                         ;
                        CALL RemoveLines                ;
                        POP IY                          ;

                        CALL DecCountIfMissile          ;

ShowObjects_NotDrawn    LD (IY+AnypCode),low RemoveLineExit   ;
                        LD (IY+AnypCode+1),high RemoveLineExit;

ShowObjects_Next        LD BC,lObje                     ;
                        ADD IX,BC                       ;

                        POP BC                          ;
                        DEC B                           ;
                        JP NZ ShowObjects_Lp            ;

                        RET                             ;

;

LDF38                   RES 0,(IX+dObjeFlag)            ; Kill it

                        BIT 3,(IX+dObjeFlag)            ; Can it be hit?
                        JR Z ShowObjects_Undraw         ; No, we're done

                        BIT 6,(IX+dObjeFlag)            ; Scores if hit?
                        JR NZ ShowObjects_Undraw        ; Yes - we're done

                        ; ??
                        BIT 6,(IX+dObjeZ+1)             ;
                        JR Z LDF59                      ;

                        LD HL,(IX+dObjeCollided)        ;
                        CALL CallHL                     ;

                        JR ShowObjects_Undraw           ;

LDF59                   LD HL,(IX+dObjeMissed)          ;
                        CALL CallHL                     ;

                        JR ShowObjects_Undraw           ;

LDF64                   RES 0,(IX+dObjeFlag)            ;
                        BIT 3,(IX+dObjeFlag)            ;
                        JR Z ShowObjects_Undraw         ;

                        BIT 6,(IX+dObjeFlag)            ;
                        JR NZ ShowObjects_Undraw        ;

                        LD HL,(IX+dObjeCollided)        ;
                        CALL CallHL                     ;

                        JR ShowObjects_Undraw           ;

; Dec the missile count if we're a missile

DecCountIfMissile       BIT 0,(IX+dObjeMiss)            ; Are we a missile?
                        RET Z                           ;

                        LD HL,nMissiles                 ; One less
                        DEC (HL)                        ;
                        RET                             ;

; This is modified NOP/RET
FireAtPlayer            NOP                             ;

                        CALL FindFreeObje               ;
                        RET C                           ;

                        LD A,3
                        CALL SubSomeStars

                        LD HL,DrawMissile               ;
                        LD (ObjeProto+dObjepMove),HL    ;

                        LD HL,MissileShot               ;
                        LD (ObjeProto+dObjeShot),HL     ;
                        LD HL,PlayerShot                ;
                        LD (ObjeProto+dObjeCollided),HL ;
                        LD HL,ProjMiss                  ;
                        LD (ObjeProto+dObjeMissed),HL   ;

                        LD HL,(IX+dObjeX)               ;
                        LD (ObjeProto+dObjeX),HL        ;

                        LD HL,(IX+dObjeY)               ;
                        LD (ObjeProto+dObjeY),HL        ;

                        LD A,%10001101                  ;
                        LD (ObjeProto+dObjeFlag),A      ;

                        LD A,$45                        ;
                        LD (ObjeProto+dObjeCol),A       ;

                        CALL CopyObjectProtoToIY        ;

                        LD A,(IX+dObjeZ)                ;
                        LD (IY+dObjeZ),A                ;
                        LD A,(IX+dObjeZ+1)              ;
                        LD (IY+dObjeZ+1),A              ;

                        LD (IY+dObjeMissAngle),0        ;
                        LD (IY+dObjeState),4            ;

                        LD (IY+dObjeMiss),1             ; It is a missile

                        LD HL,nMissiles                 ; Inc the missile count
                        INC (HL)                        ;

                        ; Calc the move vector (aim at player)

                        LD A,R                          ;
                        AND $1F                         ;
optSkillLevel_D         EQU *-1                         ;
                        ADD A,30                        ;
MissileSpeed            EQU *-1                         ;

                        EX AF,AF'                       ;

                        LD HL,(DeltaX)                  ;
                        mNegHL()                        ;
                        CALL Mul_Alt_A_And_Offset       ;
                        LD DE,(IY+dObjeX)               ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        CALL Div_Alt_A                  ;
                        LD (IY+dObjedX),HL              ;

                        LD HL,(DeltaY)                  ;
                        mNegHL()                        ;
                        CALL Mul_Alt_A_And_Offset       ;
                        LD DE,(IY+dObjeY)               ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        CALL Div_Alt_A                  ;
                        LD (IY+dObjedY),HL              ;

                        LD HL,(DeltaZ)                  ;
                        mNegHL()                        ;
                        CALL Mul_Alt_A_And_Offset       ;
                        LD DE,(IY+dObjeZ)               ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        CALL Div_Alt_A                  ;
                        LD (IY+dObjedZ),HL              ;
                        RET                             ;

Mul_Alt_A_And_Offset    EX AF,AF'                       ;
                        LD E,A                          ;
                        ADD A,$00                       ;
MissileAimError         EQU *-1                         ;
                        LD D,A                          ;
                        LD A,E                          ;
                        EX AF,AF'                       ;
                        LD E,$00                        ;
                        JP SignMult                     ;

        if false
LE04C                   LD E,$00                        ;
                        EX AF,AF'                       ;
                        LD D,A                          ;
                        EX AF,AF'                       ;
                        CALL SignDiv                    ;
                        RET                             ;
        endif

; Vectored object moves

Table_8x_ShipMoves      DEFW DrawShip_Rand0,DrawShip_Rand1,DrawShip_Rand2,DrawShip_Rand3
                        DEFW DrawShip_Rand3,DrawShip_Rand1,DrawShip_Rand2,DrawShip_Rand3

; A prototype of an object, I think...

;                        org $E000

ObjeProto               DEFW $0000                      ; X
                        DEFW $FE0C                      ; Y
                        DEFW $7FFF                      ; Z
                        DEFW $FFB0                      ; DY
                        DEFB $00                        ; State
                        DEFB $28                        ; Cnt
                        DEFW MoveObje_X3                ; Move
                        DEFB $0F                        ; Flag
                        DEFB $02                        ; HSize
                        DEFB $FF                        ; OldX
                        DEFB $FF                        ; OldZ
                        DEFB $FF,$FF,$FF,$00            ;
                        DEFB $00,$00,$00,$00,$00        ;
                        DEFB $45                        ;
                        DEFB $00,$00,$00                ;
                        DEFW $0000                      ;
                        DEFW $0000                      ;
                        DEFW Ret                        ;
                        DEFW Ret                        ;
                        DEFW Ret                        ;

                        ; Fill the object with zeros to the first line undraw data vector

                        ds (ObjeProto + dObjeLines + AnypCode)-*,$00

                        ; Now, this MUST be here or the game blows up.

                        defw RemoveLineExit             ; This is an endmarker for the line list

                        ; I suspect we don't care about any of this

                        ds (ObjeProto + $50)-*,$00      ; Fill the rest of the object and then some with zeros

                        ; I suspect this is actually correct, but never mind

;                        ds (ObjeProto + dObjeLines + lObjeLine)-*,$00      ; Fill the rest of the object with zeros

; Characters drawn in the game

                        align 256

GameChars               dg ........
                        dg .X....X.
                        dg ........
                        dg ....X...
                        dg .X......
                        dg .....X..
                        dg ..X.....
                        dg ........
                        dg ..X.....
                        dg .X..X.X.
                        dg ..X.....
                        dg ....X.X.
                        dg .X.X....
                        dg .....X..
                        dg X.X.....
                        dg ....X...
                        dg ..X..X..
                        dg .X..X.X.
                        dg X.X..X..
                        dg X...X.X.
                        dg .X.X.X..
                        dg ..X..X..
                        dg X.X...X.
                        dg .....X..
                        dg X.X..X..
                        dg .X.XX.X.
                        dg X.XX.X.X
                        dg X.X.X.X.
                        dg .X.X.X.X
                        dg ..X.XX..
                        dg X.X.X.XX
                        dg .X..X.X.
                        dg X.X..X.X
                        dg .X.XX.X.
                        dg X.XX.XXX
                        dg X.XXX.X.
                        dg .X.X.X.X
                        dg XXX.XXX.
                        dg X.XXX.XX
                        dg .XX.X.X.
                        dg X.XXXX.X
                        dg .X.XX.X.
                        dg XXXXXXX.
                        dg X.XXX.XX
                        dg .X.X.XXX
                        dg XXX.XXX.
                        dg X.XXXXXX
                        dg .XX.X.XX
                        dg XXXXXXXX
                        dg X......X
                        dg X.XXXX.X
                        dg X.X..X.X
                        dg X.X..X.X
                        dg X.XXXX.X
                        dg X......X
                        dg XXXXXXXX
                        dg ........
                        dg ........
                        dg ..XXXX..
                        dg ..X..X..
                        dg ..X..X..
                        dg ..XXXX..
                        dg ........
                        dg ........
                        dg ........
                        dg ........
                        dg ........
                        dg ...XX...
                        dg ...XX...
                        dg ........
                        dg ........
                        dg ........
GameArrows              dg ...X....
                        dg ..XXX...
                        dg .X.X.X..
                        dg ...X....
                        dg ...X....
                        dg ...X....
                        dg ...X....
                        dg ...X....
                        dg ....XXXX
                        dg ......XX
                        dg .....X.X
                        dg ....X..X
                        dg ...X....
                        dg ..X.....
                        dg .X......
                        dg X.......
                        dg ........
                        dg .....X..
                        dg ......X.
                        dg XXXXXXXX
                        dg ......X.
                        dg .....X..
                        dg ........
                        dg ........
                        dg X.......
                        dg .X......
                        dg ..X.....
                        dg ...X....
                        dg ....X..X
                        dg .....X.X
                        dg ......XX
                        dg ....XXXX
                        dg ...X....
                        dg ...X....
                        dg ...X....
                        dg ...X....
                        dg ...X....
                        dg .X.X.X..
                        dg ..XXX...
                        dg ...X....
                        dg .......X
                        dg ......X.
                        dg .....X..
                        dg ....X...
                        dg X..X....
                        dg X.X.....
                        dg XX......
                        dg XXXX....
                        dg ........
                        dg ..X.....
                        dg .X......
                        dg XXXXXXXX
                        dg .X......
                        dg ..X.....
                        dg ........
                        dg ........
                        dg XXXX....
                        dg XX......
                        dg X.X.....
                        dg X..X....
                        dg ....X...
                        dg .....X..
                        dg ......X.
                        dg .......X
                        dg ........
                        dg ........
                        dg ....XXXX
                        dg ...X....
                        dg ..X.....
                        dg ..X...XX
                        dg ..X..X..
                        dg ..X..X..
                        dg ........
                        dg ........
                        dg XXXX....
                        dg ....X...
                        dg .....X..
                        dg XX...X..
                        dg ..X..X..
                        dg ..X..X..
                        dg ..X..X..
                        dg ..X..X..
                        dg XX...X..
                        dg .....X..
                        dg ....X...
                        dg XXXX....
                        dg ........
                        dg ........
                        dg ..X..X..
                        dg ..X..X..
                        dg ..X...XX
                        dg ..X.....
                        dg ...X....
                        dg ....XXXX
                        dg ........
                        dg ........
                        dg ........
                        dg ........
                        dg ...XX...
                        dg ..XXXX..
                        dg ..XXXX..
                        dg ...XX...
                        dg ........
                        dg ........
                        dg ........
                        dg ........
                        dg ...XX...
                        dg ..XXXX..
                        dg ..XXXX..
                        dg ...XX...
                        dg ........
                        dg ........
                        dg ........
                        dg ........
                        dg ..XXXX..
                        dg ..XXXX..
                        dg ..XXXX..
                        dg ..XXXX..
                        dg ........
                        dg ........
                        dg ........
                        dg ...XX...
                        dg ..XXXX..
                        dg .XXXXXX.
                        dg .XXXXXX.
                        dg ..XXXX..
                        dg ...XX...
                        dg ........
                        dg XXXXXXXX
                        dg X......X
                        dg X..XX..X
                        dg X.XXXX.X
                        dg X.XXXX.X
                        dg X..XX..X
                        dg X......X
                        dg XXXXXXXX
                        dg XXXXXXXX
                        dg X......X
                        dg X..XX..X
                        dg X.XXXX.X
                        dg X.XXXX.X
                        dg X..XX..X
                        dg X......X
                        dg XXXXXXXX
                        dg XXXXXXXX
                        dg X..XX..X
                        dg X.XXXX.X
                        dg X.XXXX.X
                        dg X.XXXX.X
                        dg X.XXXX.X
                        dg X..XX..X
                        dg XXXXXXXX
                        dg XXXXXXXX
                        dg X..XX..X
                        dg X.XXXX.X
                        dg XXXXXXXX
                        dg XXXXXXXX
                        dg X.XXXX.X
                        dg X..XX..X
                        dg XXXXXXXX
                        dg XXXXXXXX
                        dg X......X
                        dg X......X
                        dg X......X
                        dg X......X
                        dg X......X
                        dg X......X
                        dg XXXXXXXX
                        dg ........
                        dg ........
                        dg ........
                        dg ........
                        dg ........
                        dg ........
                        dg ........
                        dg ........
                        dg ........
                        dg ........
                        dg ........
                        dg ........
                        dg ........
                        dg ........
                        dg ........
                        dg ........

; The bonnet

JonsGraphic             DEFB $00,$00,$00,$07,$FF,$FF,$FC,$00
                        DEFB $FF,$FF,$F0,$00,$00,$00,$00,$00
                        DEFB $00,$00,$00,$78,$00,$00,$7F,$FF
                        DEFB $80,$03,$C8,$00,$00,$00,$00,$00
                        DEFB $00,$00,$07,$FF,$FF,$FF,$A0,$1E
                        DEFB $7F,$CF,$34,$00,$00,$00,$00,$00
                        DEFB $00,$00,$78,$00,$00,$1F,$FF,$F1
                        DEFB $FF,$3C,$DA,$00,$03,$FF,$00,$00
                        DEFB $00,$07,$FF,$FF,$FF,$E8,$03,$CF
                        DEFB $FC,$F3,$6D,$00,$00,$01,$00,$00
                        DEFB $00,$38,$00,$00,$07,$FF,$FE,$3F
                        DEFB $F3,$CD,$B6,$80,$0F,$FE,$80,$00
                        DEFB $00,$FF,$FF,$FF,$FA,$00,$38,$00
                        DEFB $0F,$36,$DB,$7F,$E0,$03,$6D,$BF
                        DEFB $01,$FF,$FF,$FF,$FF,$FF,$FF,$FF
                        DEFB $FF,$DB,$6D,$C0,$DF,$FD,$6D,$A0
                        DEFB $03,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$ED,$B7,$FF,$80,$06,$DB,$7F
                        DEFB $06,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$76,$DB,$03,$7F,$FA,$DB,$40
                        DEFB $0C,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$3B,$6F,$FE,$00,$0D,$B7,$7F
                        DEFB $18,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$1D,$B8,$0D,$55,$55,$B6,$C0
                        DEFB $30,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$0E,$DF,$FA,$AA,$AB,$6E,$FF
                        DEFB $60,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$07,$60,$39,$55,$53,$6E,$80
                        DEFB $C0,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$03,$FF,$FF,$FF,$FF,$FF,$FF
                        DEFB $80,$00,$00,$00,$00,$00,$00,$00
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00

Save_Limit              equ *

; Scale a Y of 0..255 to a screen-Y (allowing for the display furniture)
DivTab                  ds $100

; Y Table (convert to screen)
YTable                  DS $200

; Map
Map                     ds $200
MapOfPlanet             ds $100
BitTab                  ds 24
CurrMapPosition         db 0
nBasesOnPlanet          db 0

DeltaX                  DEFW 0
FireDX                  DEFW 0
DeltaY                  DEFW 0
FireDY                  DEFW 0
DeltaZ                  DEFW 0
FireDZ                  DEFW 0
Colour                  DEFB 0
GameMode_SPT            DEFB $00

XTurnRatio              DEFW 0
YDiveRatio              DEFW 0

Stars_nDem              DEFB 0

TempX                   DEFW 0
TempY                   DEFW 0
TempZ                   DEFW 0

bUseAnalog_JS           DB 0

cSecCount               DB 0

; Build the keys into this table

UDK_Code                ds $1C0

                        align 256

ObjeTable               ds nObjes * lObje
GroundY                 dw 0
StarTable               ds nStars * lStar
ProjTable               ds nProjs * lProj
lTables                 equ * - ObjeTable

; The front-end copies the screen attributes to here.

AttrBuff                ds $300

; Only the stack is above here

Ye_End                  equ *

