;

ClearStarsAndProjs      LD IX,StarTable
                        LD B,nStars
                        LD DE,lStar
ClearStarsLp            LD HL,(IX+dStarAddr)
                        LD A,(IX+dStarBit)
                        CPL
                        AND (HL)
                        LD (HL),A
                        ADD IX,DE
                        DJNZ ClearStarsLp

                        LD IX,ProjTable
                        LD B,nProjs
                        LD DE,lProj
ClearProjsLp            LD HL,(IX+dProjAddr)
                        LD A,(IX+dProjBit)
                        CPL
                        AND (HL)
                        LD (HL),A
                        ADD IX,DE
                        DJNZ ClearProjsLp

                        RET

; Projectiles

InitProj                LD IX,ProjTable
                        LD B,nProjs
                        LD DE,lProj
                        XOR A
IP_Lp                   LD (IX+dProjLife),A
                        ADD IX,DE
                        DJNZ IP_Lp

                        XOR A
                        LD (SideSel),A
                        LD A,$40
                        LD (TopSel),A
                        RET

ShowProj                LD IX,ProjTable
                        LD B,nProjs
ShowProjLp              PUSH BC
                        LD A,(IX+dProjLife)
                        OR A
                        JP Z ShowProjNext

                        XOR A
                        OUT ($FE),A
smcNoise6               EQU *-1

                        LD HL,(IX+dProjX)
                        LD A,H
                        LD BC,(DeltaX)
                        ADD HL,BC
                        LD BC,(IX+dProjDX)
                        ADD HL,BC
                        LD (IX+dProjX),HL
                        ADD A,H
                        RRA
                        LD (LB33C),A
                        LD HL,(IX+dProjY)
                        LD A,H
                        LD BC,(DeltaY)
                        ADD HL,BC
                        LD BC,(IX+dProjDY)
                        ADD HL,BC
                        LD (IX+dProjY),HL
                        LD (LB34E),HL
                        ADD A,H
                        RRA
                        LD (LB368),A
                        LD BC,(GroundY)
                        OR A
                        SBC HL,BC
                        BIT 7,H
                        JR NZ LB2D4

                        LD A,(GameMode_SPT)
                        OR A
                        JR NZ LB2D4

                        LD (IX+dProjY+1),B
                        LD (IX+dProjLife),$01
LB2D4                   LD HL,(IX+dProjZ)
                        LD A,H
                        LD (LB32C),A
                        LD BC,(DeltaZ)
                        ADD HL,BC
                        LD BC,(IX+dProjDZ)
                        ADD HL,BC
                        LD (IX+dProjZ),HL
                        LD A,H
                        LD (LB326),A
                        LD A,(IX+dProjBit)
                        LD HL,(IX+dProjAddr)
                        CPL
                        AND (HL)
                        LD (HL),A
                        LD (IX+dProjBit),$00
                        LD A,$00
LB305                   EQU *-1
                        OUT ($FE),A
smcNoise7               EQU *-1

                        BIT 7,(IX+dProjZ+1)
                        JP NZ ShowProjKillProj

                        DEC (IX+dProjLife)
                        JP Z ShowProjNext

                        LD IY,ObjeTable
                        LD B,nObjes
HitLp                   LD A,(IY+dObjeFlag)

                        ; Dead or can't stop bullets

                        XOR $01
                        AND $21
                        JR NZ HitLpNext

                        ; Can stop them

                        PUSH BC
                        LD A,$00
LB326                   EQU *-1
                        SUB (IY+dObjeZ+1)
                        LD B,A
                        LD A,$00
LB32C                   EQU *-1
                        SUB (IY+dObjeOldZ)
                        XOR B
                        JP P HitLpNextPop

                        LD A,(IY+dObjeOldX)
                        ADD A,(IY+dObjeX+1)
                        RRA
                        SUB $00
LB33C                   EQU *-1
                        JP P LB342

                        NEG
LB342                   CP (IY+dObjeHSize)
                        JR NC HitLpNextPop

                        BIT 7,(IY+dObjeFlag)
                        JR NZ LB360

                        LD HL,$0000
LB34E                   EQU *-2
                        LD DE,(IY+dObjeY)
                        OR A
                        SBC HL,DE
                        BIT 7,H
                        JR Z ProjHitObje

                        JP HitLpNextPop

LB360                   LD A,(IY+dObjeOldY)
                        ADD A,(IY+dObjeY+1)
                        RRA
                        SUB $00
LB368                   EQU *-1
                        JP P LB36E

                        NEG
LB36E                   CP (IY+dObjeHSize)
                        JR NC HitLpNextPop

                        JP ProjHitObje

HitLpNextPop            POP BC
HitLpNext               LD DE,lObje
                        ADD IY,DE
                        DJNZ HitLp

HO3                     LD HL,(IX+dProjX)
                        LD DE,(IX+dProjZ)
                        BIT 7,H
                        JR NZ LB3B4

                        OR A
                        SBC HL,DE
                        JP NC ShowProjNext

                        ADD HL,DE
                        CALL DivHLDE
                        SRL H
                        RR L
                        JP LB3CF

ProjHitObje             PUSH IY
                        LD (IX+dProjLife),$00
                        LD HL,(IY+dObjeShot)
                        CALL CallHL
                        POP IY
                        POP BC
                        JP ShowProjNext

LB3B4                   LD A,L
                        CPL
                        LD L,A
                        LD A,H
                        CPL
                        LD H,A
                        INC HL
                        OR A
                        SBC HL,DE
                        JP NC ShowProjNext

                        ADD HL,DE
                        CALL DivHLDE
                        SRL H
                        RR L
                        LD A,L
                        CPL
                        LD L,A
                        LD H,$FF
                        INC HL
LB3CF                   PUSH HL
                        LD HL,(IX+dProjY)
                        LD DE,(IX+dProjZ)
                        BIT 7,H
                        JR NZ LB3F1

                        OR A
                        SBC HL,DE
                        JP NC ShowProjNextPop

                        ADD HL,DE
                        CALL DivHLDE
                        SRL H
                        RR L
                        JP LB40C

LB3F1                   LD A,L
                        CPL
                        LD L,A
                        LD A,H
                        CPL
                        LD H,A
                        INC HL
                        OR A
                        SBC HL,DE
                        JP NC ShowProjNextPop

                        ADD HL,DE
                        CALL DivHLDE
                        SRL H
                        RR L
                        LD A,L
                        CPL
                        LD L,A
                        LD H,$FF
                        INC HL

LB40C                   POP DE
                        CALL CalcAddr
                        LD (IX+dProjAddr),HL
                        LD (IX+dProjBit),A
                        OR (HL)
                        LD (HL),A
ShowProjNext            LD BC,lProj
                        ADD IX,BC
                        POP BC
                        DEC B
                        JP NZ ShowProjLp

                        RET

ShowProjKillProj        LD (IX+dProjLife),$00
                        LD A,(IX+dProjBit)
                        CPL
                        LD HL,(IX+dProjAddr)
                        AND (HL)
                        LD (HL),A
                        LD (IX+dProjBit),$00
                        PUSH AF

ShowProjNextPop         POP AF
                        LD BC,lProj
                        ADD IX,BC
                        POP BC
                        DEC B
                        JP NZ ShowProjLp

                        RET

CheckPlayerFire         LD A,(Player_nShots)
                        OR A
                        JR NZ CPF_MoreShots

                        XOR A
                        LD (LB305),A
                        CALL ReadKey_Fire
                        RET Z

LB455                   LD A,12
                        LD (Player_nShots),A
LB45A                   LD A,$F8
                        LD (LB305),A
                        LD A,(LB489)
                        INC A
                        LD (LB489),A
                        AND $01
                        RET NZ

                        ; Fire a projectile

                        LD IX,ProjTable
                        LD B,nProjs
                        LD DE,lProj

FindFreeProjLp          LD A,(IX+dProjLife)
                        OR A
                        JR Z AddProj

                        ADD IX,DE
                        DJNZ FindFreeProjLp

                        RET

CPF_MoreShots           DEC A
                        LD (Player_nShots),A
                        CALL ReadKey_Fire
                        JR Z LB45A

                        JR LB455

Player_nShots           DEFB 0
LB489                   DEFB $00

; Add a projectile to the list

AddProj                 LD (IX+dProjLife),20
                        XOR A
                        LD (IX+dProjY+1),A
                        LD (IX+dProjZ),A
                        LD (IX+dProjZ+1),A
                        LD (IX+dProjBit),A

                        LD HL,(FireDX)
                        LD (IX+dProjDX),HL
                        LD HL,(FireDY)
                        LD (IX+dProjDY),HL
                        LD HL,(FireDZ)
                        LD (IX+dProjDZ),HL
                        LD A,$00
SideSel                 EQU *-1
                        CPL
                        LD (SideSel),A
                        OR A
                        JR NZ AP_1

                        LD A,$00
TopSel                  EQU *-1
                        XOR $80
                        LD (TopSel),A
AP_1                    LD A,(SideSel)
                        LD (IX+dProjX+1),A
                        LD (IX+dProjX),$80
                        LD A,(TopSel)
                        LD (IX+dProjY),A
                        RET


